import pytest


@pytest.mark.parametrize(
    "q, expected_hits",
    [
        ["flexibel", 967],
        ["ansvarstagande", 468],
        ["noggrann", 608],
        ["positiv", 841],
        ["driven", 520],
        ["samarbetsförmåga", 616],
        ["engagerad", 574],
        ["social", 646],
        pytest.param("kommunikativ", 359, marks=pytest.mark.smoke),
        ["strukturerad", 461],
        ["lyhörd", 439],
        ["självgående", 437],
        ["arbeta självständigt", 3194],
        ["serviceinriktad", 332],
        ["lösningsorienterad", 191],
        ["initiativrik", 95],
        ["nyfikenhet", 129],
        ["kreativ", 256],
        ["självständig", 230],
        ["lagspelare", 207],
        ["prestigelös", 247],
        ["målinriktad", 102],
        ["analytisk", 174],
        ["tydlig", 368],
        pytest.param("stresstålig", 164, marks=pytest.mark.smoke),
        ["lugn", 215],
        ["ödmjukhet", 37],
        ["utåtriktad", 138],
        ["stabil", 198],
        ["drivande", 168],
        ["resultatinriktad", 74],
        ["ordningsam", 109],
        ["ambition", 210],
        ["affärsmässig", 39],
        ["kvalitetsmedveten", 83],
        ["pedagogisk", 258],
        ["integritet", 128],
        ["nytänkande", 187],
        ["professionell", 207],
        ["effektiv", 204],
        ["pålitlig", 94],
        ["servicekänsla", 78],
        ["arbetsmoral", 80],
        ["serviceminded", 69],
        pytest.param("empatisk", 71, marks=pytest.mark.smoke),
        ["framtidstro", 89],
        ["samarbetsvillig", 62],
        ["relationsskapande", 60],
        ["mognad", 50],
        ["förtroendeingivande", 57],
        ["omdöme", 55],
        ["ärlighet", 34],
        ["kundorienterad", 36],
        ["uthållig", 50],
        ["hjälpsam", 52],
        ["gillar utmaningar", 1111],
        ["självinsikt", 34],
        ["lojal", 47],
        ["administrativ", 76],
        ["tävlingsinriktad", 38],
        ["framåtanda", 50],
        ["snabb", 124],
        ["proaktiv", 59],
        ["handlingskraftig", 42],
        ["orädd", 41],
        ["ordningssinne", 36],
        ["tillmötesgående", 38],
        ["energisk", 40],
        ["strategisk", 97],
        ["metodiskt", 21],
        ["uppmärksam", 35],
        ["verbal", 52],
        ["utvecklingsinriktad", 23],
        ["trevlig", 128],
        ["driftig", 32],
        ["arbetsvillig", 21],
        ["humor", 41],
        ["motiverad", 45],
        ["problemlösningsförmåga", 26],
        ["problemlösande", 31],
        ["anpassningsbar", 22],
        ["organisationsförmåga", 23],
        ["teamkänsla", 45],
        ["doer", 16],
        ["omtänksam", 30],
        ["innovativ", 73],
        ["inger förtroende", 195],
        ["entusiastisk", 24],
        ["planeringsförmåga", 12],
        ["passionerad", 22],
        ["modig", 22],
        ["relationsbyggande", 20],
        ["entreprenörsanda", 28],
        ["ihärdig", 8],
        ["inkännande", 7],
        ["fokuserad", 31],
        ["säkerhetstänk", 19],
        ["tänkande", 26],
        ["vänlig", 58],
        ["vetgirig", 17],
        ["tålmodig", 16],
        ["praktiskt lagd", 137],
        pytest.param("rolig", 67, marks=pytest.mark.smoke),
        ["hunger", 9],
        ["serviceanda", 14],
        ["operativ", 44],
        ["pigg", 18],
        ["varm", 33],
        ["tävlingsmänniska", 21],
        ["idérik", 12],
        ["kvalitetstänk", 11],
        ["säkerhetsmedveten", 13],
        ["samarbetsinriktad", 6],
        ["systematisk", 21],
        ["säljinriktad", 4],
        ["rak", 19],
        ["snabblärd", 12],
        ["lättsam", 12],
        ["entusiasm", 14],
        ["logiskt", 5],
        ["lagkänsla", 17],
        ["välorganiserad", 15],
        ["transparent", 23],
        ["sunt förnuft", 17],
        ["lyssnare", 9],
        ["siffersinne", 10],
        ["lättlärd", 10],
        ["dynamisk", 128],
    ],
)
def test_freetext_search_for_traits(q, expected_hits, client):
    # Arrange
    query = {"q": q, "limit": 0}

    # Act
    response = client.get("/search", query_string=query)

    # Assert
    assert response.status_code == 200
    assert response.json["total"]["value"] == expected_hits
